function logMhoShareMsg(message) {
	var consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	consoleService.logStringMessage("Mahalo: " + message);
}

function mhos_launchUrl(url, clickEvent) {
	this._addTab = function (url) {
		var theTab = gBrowser.addTab(url);

		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

		var loadInBackground = false;

		try {
			loadInBackground = prefs.getBoolPref("browser.tabs.loadInBackground");
		} catch (e) {
		}

		if (!loadInBackground){
			gBrowser.selectedTab = theTab;
		}
	};
	
	this._inTab = function (url) {
		content.document.location.href = url;
	};
	
	if (!clickEvent) {
		this._inTab(url);
	}
	else if ((clickEvent.which == 2) || (clickEvent.which == 1 && (clickEvent.ctrlKey || clickEvent.metaKey))){
		this._addTab(url);
	}
	else if (clickEvent.which == 1){
		this._inTab(url);
	}
	else if (clickEvent.which == 4){
		window.open(url);
	}
}

function mhos_inArray(arr, val) {
	var len = arr.length;
	
	for (var i = 0; i < len; i++){
		if (arr[i] === val) {
			return true;
		}
	}
	
	return false;
}

function logMhoShareError(text) {
	var date = new Date().toUTCString();
	
	appendToMhoShareProfileFile("mho-share-log.txt", date + ": " + text + "\n\n");
}

function appendToMhoShareProfileFile(name, data) {
	var DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
	var profilePath = (new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
	
	if (profilePath.search(/\\/) != -1) profilePath += "\\";
	else profilePath += "/";
	
	var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(profilePath + name);

	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );

	outputStream.init(file, 0x02 | 0x08 | 0x10, 0600, null);
	
	var bytes, bytesWritten, bytesRemaining = data.length;
	var offset = 0;
		
	while (bytesRemaining) {
		bytesWritten = outputStream.write(data.substring(offset), bytesRemaining);
		bytesRemaining -= bytesWritten;
		offset += bytesWritten;
	}
	
	return true;
}

function mhos_timestamp() {
	var now = new Date();
	now = Math.round(now.getTime() / 1000);
	return now;
}

function mhos_hash(str, method, hex) {
	var hash_engine;

	try {
		hash_engine = Components.classes["@mozilla.org/security/hash;1"].createInstance(Components.interfaces["nsICryptoHash"]);
		hash_engine.initWithString(method);
		
		var charcodes = new Array();

		for (var i = 0; i < str.length; i++)
			charcodes.push(str.charCodeAt(i));

		hash_engine.update(charcodes, str.length);
		
		if (hex) {			
			var hash = hash_engine.finish(false);
			
			function toHexString(charCode) {
			  return ("0" + charCode.toString(16)).slice(-2);
			}

			// convert the binary hash data to a hex string.
			var s = [toHexString(hash.charCodeAt(i)) for (i in hash)].join("");
			return s;
		}
		else {
			return hash_engine.finish(true);
		}
	}
	catch (e) {
		return null;
	}
}